package me.wazup.hideandseek.listeners;

import org.bukkit.command.CommandSender;
import org.bukkit.event.server.ServerListPingEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.World;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.event.entity.ProjectileLaunchEvent;
import org.bukkit.projectiles.ProjectileSource;
import org.bukkit.entity.Projectile;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.inventory.meta.FireworkMeta;
import com.google.common.io.ByteArrayDataOutput;
import org.bukkit.inventory.Inventory;
import org.bukkit.util.Vector;
import org.bukkit.entity.EntityType;
import org.bukkit.block.BlockState;
import java.util.HashMap;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.Color;
import org.bukkit.FireworkEffect;
import me.wazup.hideandseek.managers.AchievementsManager;
import org.bukkit.plugin.Plugin;
import com.google.common.io.ByteStreams;
import me.wazup.hideandseek.xseries.XMaterial;
import java.util.Collection;
import java.util.ArrayList;
import me.wazup.hideandseek.Customization;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.Bukkit;
import me.wazup.hideandseek.Perk;
import org.bukkit.Material;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.entity.FoodLevelChangeEvent;
import java.util.Iterator;
import org.bukkit.entity.Item;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.Effect;
import org.bukkit.Location;
import me.wazup.hideandseek.utils.Utils;
import org.bukkit.entity.Firework;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.entity.Entity;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import me.wazup.hideandseek.managers.FilesManager;
import org.bukkit.block.Sign;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.ChatColor;
import me.wazup.hideandseek.PlayerData;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.EventHandler;
import org.bukkit.entity.Player;
import me.wazup.hideandseek.Arena;
import me.wazup.hideandseek.Config;
import org.bukkit.event.player.PlayerLoginEvent;
import me.wazup.hideandseek.HideAndSeek;
import org.bukkit.event.Listener;

public class HASListener implements Listener
{
    private final HideAndSeek plugin;
    
    public HASListener(final HideAndSeek plugin) {
        this.plugin = plugin;
    }
    
    @EventHandler
    public void onPlayerLogin(final PlayerLoginEvent playerLoginEvent) {
        final Player player = playerLoginEvent.getPlayer();
        if (Config.getInstance().bungeeEnabled) {
            if (Arena.arenaObjects.size() == 0) {
                playerLoginEvent.disallow(PlayerLoginEvent.Result.KICK_OTHER, (String)this.plugin.customization.messages.get("no_arenas"));
                return;
            }
            boolean b = false;
            if (this.plugin.bungeeMode.selectedArena != null) {
                if (!this.plugin.spectateEnabled || (this.plugin.bungeeMode.selectedArena.state != Arena.ArenaState.INGAME && this.plugin.bungeeMode.selectedArena.state != Arena.ArenaState.ENDING)) {
                    playerLoginEvent.disallow(PlayerLoginEvent.Result.KICK_OTHER, (String)this.plugin.customization.messages.get("arena_not_available"));
                    return;
                }
                b = true;
            }
            if (playerLoginEvent.getResult().equals((Object)PlayerLoginEvent.Result.KICK_FULL) && (player.hasPermission("hideandseek.joinfull") || b)) {
                playerLoginEvent.setResult(PlayerLoginEvent.Result.ALLOWED);
            }
        }
    }
    
    @EventHandler
    public void onPlayerJoin(final PlayerJoinEvent playerJoinEvent) {
        final Player player = playerJoinEvent.getPlayer();
        this.plugin.playerData.put(player.getName(), new PlayerData(player));
        if (Config.getInstance().bungeeEnabled) {
            playerJoinEvent.setJoinMessage((String)null);
            if (this.plugin.bungeeMode.selectedArena != null) {
                if (this.plugin.spectateEnabled && (this.plugin.bungeeMode.selectedArena.state == Arena.ArenaState.INGAME || this.plugin.bungeeMode.selectedArena.state == Arena.ArenaState.ENDING)) {
                    this.plugin.spectatorJoin(player, this.plugin.bungeeMode.selectedArena);
                }
            }
            else {
                this.plugin.bungeeMode.join(player, false);
            }
        }
        if (player.hasPermission("hideandseek.admin")) {
            if (this.plugin.availableUpdate) {
                player.sendMessage(this.plugin.customization.prefix + "Found a new available version! " + ChatColor.LIGHT_PURPLE + "download at https://goo.gl/1xxolH");
            }
            else {
                this.plugin.checkUpdates(player);
            }
        }
    }
    
    @EventHandler
    public void onPlayerLeave(final PlayerQuitEvent playerQuitEvent) {
        final Player player = playerQuitEvent.getPlayer();
        ((PlayerData)this.plugin.playerData.get(player.getName())).saveStats(player, true);
        if (this.plugin.game.contains(player.getName())) {
            if (Config.getInstance().bungeeEnabled) {
                playerQuitEvent.setQuitMessage((String)null);
                this.plugin.bungeeMode.leave(player);
            }
            else {
                player.performCommand("has leave");
            }
        }
        this.plugin.playerData.remove(player.getName());
    }
    
    @EventHandler
    public void onBlockBreak(final BlockBreakEvent blockBreakEvent) {
        final Player player = blockBreakEvent.getPlayer();
        if (this.plugin.game.contains(player.getName()) && !this.plugin.editmode.contains(player.getName())) {
            blockBreakEvent.setCancelled(true);
            return;
        }
        if (blockBreakEvent.getBlock().getState() instanceof Sign && !blockBreakEvent.isCancelled()) {
            final Sign sign = (Sign)blockBreakEvent.getBlock().getState();
            if (sign.getLine(0).equals(this.plugin.customization.sign_prefix)) {
                if (!player.hasPermission("hideandseek.breaksigns")) {
                    player.sendMessage((String)this.plugin.customization.messages.get("no_permission"));
                    blockBreakEvent.setCancelled(true);
                    return;
                }
                if (sign.getLine(1).contains("Top #")) {
                    final int intValue = Integer.valueOf(sign.getLine(1).split("#")[1]);
                    if (FilesManager.getInstance().getConfig("signs.yml").contains("Signs.Top." + intValue)) {
                        FilesManager.getInstance().getConfig("signs.yml").set("Signs.Top." + intValue, (Object)null);
                        FilesManager.getInstance().saveConfig("signs.yml");
                        player.sendMessage(this.plugin.customization.prefix + "You have " + ChatColor.GREEN + "successfully" + ChatColor.GOLD + " removed a top sign!");
                    }
                    final boolean b = this.plugin.updater != null;
                    this.plugin.fixUpdater();
                    if (b && this.plugin.updater == null) {
                        player.sendMessage(this.plugin.customization.prefix + "The sign updater has been stopped");
                    }
                    return;
                }
                final Arena value = Arena.valueOf(ChatColor.stripColor(sign.getLine(1)));
                if (value != null) {
                    value.sign = null;
                    value.updateBehindSign();
                    FilesManager.getInstance().getConfig("signs.yml").set("Signs.Join." + value.name, (Object)null);
                    FilesManager.getInstance().saveConfig("signs.yml");
                    player.sendMessage(this.plugin.customization.prefix + "You have " + ChatColor.GREEN + "successfully" + ChatColor.GOLD + " removed a join sign!");
                }
            }
        }
    }
    
    @EventHandler
    public void onBlockPlace(final BlockPlaceEvent blockPlaceEvent) {
        final Player player = blockPlaceEvent.getPlayer();
        if (this.plugin.game.contains(player.getName()) && !this.plugin.editmode.contains(player.getName())) {
            blockPlaceEvent.setCancelled(true);
        }
    }
    
    @EventHandler
    public void onBombExpload(final EntityExplodeEvent entityExplodeEvent) {
        final Entity entity = entityExplodeEvent.getEntity();
        if (entity != null && (entity.hasMetadata("damageSeekers") || entity.hasMetadata("damageHiders"))) {
            entityExplodeEvent.blockList().clear();
        }
    }
    
    @EventHandler
    public void onPlayerDropItem(final PlayerDropItemEvent playerDropItemEvent) {
        if (this.plugin.game.contains(playerDropItemEvent.getPlayer().getName())) {
            playerDropItemEvent.setCancelled(true);
        }
    }
    
    @EventHandler
    public void onPlayerPickUpItems(final PlayerPickupItemEvent playerPickupItemEvent) {
        final Player player = playerPickupItemEvent.getPlayer();
        if (this.plugin.game.contains(player.getName())) {
            playerPickupItemEvent.setCancelled(true);
            final Item item = playerPickupItemEvent.getItem();
            if (!item.getItemStack().getItemMeta().hasDisplayName()) {
                return;
            }
            if (item.getItemStack().getItemMeta().getDisplayName().contains(this.plugin.powerup_marker)) {
                final Arena arena = this.plugin.playerData.get(player.getName()).arena;
                if (arena.hiders.contains(player.getName())) {
                    item.getWorld().spawn(item.getLocation(), (Class)Firework.class);
                    for (final Location location : Utils.getCircle(item.getLocation(), Integer.valueOf(5), Integer.valueOf(2), Boolean.valueOf(false), Boolean.valueOf(false), 1)) {
                        location.getWorld().playEffect(location, Effect.MOBSPAWNER_FLAMES, 1);
                    }
                    player.getInventory().addItem(new ItemStack[] { item.getItemStack() });
                    item.remove();
                    player.addPotionEffect(new PotionEffect(PotionEffectType.SLOW, 40, 10));
                    final String replace = this.plugin.customization.messages.get("powerup_pick").replace("%player%", player.getName());
                    for (final Player player2 : arena.getPlayers(true)) {
                        player2.sendMessage(replace);
                        Utils.playSound(player2, "Powerup-Pickup");
                    }
                }
            }
        }
    }
    
    @EventHandler
    public void onPlayerLoseFood(final FoodLevelChangeEvent foodLevelChangeEvent) {
        if (this.plugin.game.contains(foodLevelChangeEvent.getEntity().getName())) {
            foodLevelChangeEvent.setCancelled(true);
        }
    }
    
    @EventHandler
    public void onPlayerInteract(final PlayerInteractEvent playerInteractEvent) {
        final Player player = playerInteractEvent.getPlayer();
        if (playerInteractEvent.getAction().equals((Object)Action.RIGHT_CLICK_BLOCK) && playerInteractEvent.getClickedBlock().getState() instanceof Sign) {
            final Sign sign = (Sign)playerInteractEvent.getClickedBlock().getState();
            if (sign.getLine(0).equals(this.plugin.customization.sign_prefix)) {
                if (((PlayerData)this.plugin.playerData.get(player.getName())).hasCooldown(player, "signs", 3, true)) {
                    return;
                }
                final String line = sign.getLine(1);
                if (line.contains("Top #")) {
                    return;
                }
                if (line.equals(this.plugin.customization.sign_stats)) {
                    player.performCommand("has stats");
                    return;
                }
                if (line.equals(this.plugin.customization.sign_shop)) {
                    if (this.plugin.game.contains(player.getName())) {
                        this.plugin.shopping.add(player.getName());
                        player.openInventory(this.plugin.shopInventory);
                    }
                    else {
                        player.sendMessage((String)this.plugin.customization.messages.get("not_in_game"));
                    }
                    return;
                }
                if (line.equals(this.plugin.customization.sign_autojoin)) {
                    player.performCommand("has autojoin");
                    player.updateInventory();
                    return;
                }
                if (line.equals(this.plugin.customization.sign_leave)) {
                    if (player.getItemInHand().getType() != Material.AIR) {
                        player.sendMessage((String)this.plugin.customization.messages.get("empty_hand_sign_error"));
                        return;
                    }
                    player.performCommand("has leave");
                    player.updateInventory();
                }
                else {
                    if (line.equals(this.plugin.customization.sign_join_default)) {
                        if (this.plugin.joinGui != null) {
                            player.performCommand("has join");
                        }
                        return;
                    }
                    final Arena value = Arena.valueOf(ChatColor.stripColor(line));
                    if (value != null) {
                        if (player.getItemInHand().getType() != Material.AIR) {
                            player.sendMessage((String)this.plugin.customization.messages.get("empty_hand_sign_error"));
                            return;
                        }
                        player.performCommand("has join " + value.name);
                        player.updateInventory();
                    }
                }
            }
            return;
        }
        if (this.plugin.game.contains(player.getName())) {
            if (playerInteractEvent.getAction().equals((Object)Action.RIGHT_CLICK_AIR) || playerInteractEvent.getAction().equals((Object)Action.RIGHT_CLICK_BLOCK)) {
                final ItemStack itemInHand = player.getItemInHand();
                if (itemInHand.getType() != Material.AIR) {
                    if (itemInHand.getItemMeta().hasDisplayName() && itemInHand.getItemMeta().getDisplayName().contains("Mob: ")) {
                        playerInteractEvent.setCancelled(true);
                        return;
                    }
                    if (itemInHand.getType().equals((Object)Perk.DisguiseSelector.purchased.getType()) || (itemInHand.getType().equals((Object)Perk.DisguiseChanger.purchased.getType()) && itemInHand.hasItemMeta() && itemInHand.getItemMeta().hasDisplayName() && itemInHand.getItemMeta().getDisplayName().equals(Perk.DisguiseChanger.purchased.getItemMeta().getDisplayName()))) {
                        playerInteractEvent.setCancelled(true);
                        final Arena arena = this.plugin.playerData.get(player.getName()).arena;
                        final PlayerData playerData = this.plugin.playerData.get(player.getName());
                        if (playerData.specialBlocks.isEmpty()) {
                            player.openInventory(arena.disguisesInventory);
                        }
                        else {
                            final int n = arena.disguises.size() + playerData.specialBlocks.size();
                            final Inventory inventory = Bukkit.createInventory((InventoryHolder)null, (n < 10) ? 9 : ((n < 19) ? 18 : ((n < 28) ? 27 : ((n < 37) ? 36 : ((n < 46) ? 45 : 54)))), (String)this.plugin.customization.inventories.get("Disguise-Selector"));
                            final Iterator iterator = arena.disguises.iterator();
                            while (iterator.hasNext()) {
                                inventory.addItem(new ItemStack[] { (ItemStack)iterator.next() });
                            }
                            final Iterator iterator2 = playerData.specialBlocks.iterator();
                            while (iterator2.hasNext()) {
                                inventory.addItem(new ItemStack[] { (ItemStack)iterator2.next() });
                            }
                            player.openInventory(inventory);
                        }
                        return;
                    }
                    if (Utils.compareItem(itemInHand, (ItemStack)Customization.getInstance().items.get("Vote"))) {
                        playerInteractEvent.setCancelled(true);
                        if (Config.getInstance().bungeeEnabled) {
                            final Inventory inventory2 = Bukkit.createInventory((InventoryHolder)null, 18, ChatColor.DARK_RED + "Vote");
                            final ArrayList list = new ArrayList(this.plugin.playerData.get(player.getName()).votes);
                            final ArrayList c = new ArrayList();
                            int n2 = 9;
                            for (final Arena arena2 : Arena.arenaObjects) {
                                inventory2.addItem(new ItemStack[] { arena2.voteItem });
                                int i = 7;
                                final Iterator iterator4 = list.iterator();
                                while (iterator4.hasNext()) {
                                    if (((String)iterator4.next()).equals(arena2.name)) {
                                        c.add(arena2.name);
                                    }
                                }
                                list.removeAll(c);
                                if (c.size() == 1) {
                                    i = 5;
                                }
                                if (c.size() == 2) {
                                    i = 4;
                                }
                                if (c.size() == 3) {
                                    i = 14;
                                }
                                c.clear();
                                inventory2.setItem(n2, ((XMaterial)XMaterial.matchXMaterial("STAINED_GLASS_PANE:" + i).get()).parseItem());
                                ++n2;
                            }
                            player.openInventory(inventory2);
                        }
                        return;
                    }
                    if (Utils.compareItem(itemInHand, (ItemStack)Customization.getInstance().items.get("Quit"))) {
                        playerInteractEvent.setCancelled(true);
                        if (Config.getInstance().bungeeEnabled) {
                            final ByteArrayDataOutput dataOutput = ByteStreams.newDataOutput();
                            dataOutput.writeUTF("Connect");
                            dataOutput.writeUTF(this.plugin.bungeeMode.hub);
                            player.sendPluginMessage((Plugin)this.plugin, "BungeeCord", dataOutput.toByteArray());
                        }
                        else {
                            player.performCommand("has leave");
                            player.updateInventory();
                        }
                        return;
                    }
                    if (Utils.compareItem(itemInHand, (ItemStack)Customization.getInstance().items.get("Shop"))) {
                        playerInteractEvent.setCancelled(true);
                        this.plugin.shopping.add(player.getName());
                        player.openInventory(this.plugin.shopInventory);
                        return;
                    }
                    if (Utils.compareItem(itemInHand, (ItemStack)Customization.getInstance().items.get("Achievements"))) {
                        playerInteractEvent.setCancelled(true);
                        final PlayerData playerData2 = HideAndSeek.getInstance().playerData.get(player.getName());
                        (playerData2.achievements = AchievementsManager.getInstance().getAchievementsInventory(playerData2)).open(player);
                        return;
                    }
                    if (Utils.compareItem(itemInHand, (ItemStack)Customization.getInstance().items.get("Trails"))) {
                        if (this.plugin.trailsInventory != null) {
                            player.openInventory(this.plugin.trailsInventory);
                        }
                        return;
                    }
                    if (itemInHand.getType().equals((Object)this.plugin.firework.getType())) {
                        playerInteractEvent.setCancelled(true);
                        final PlayerData playerData3 = this.plugin.playerData.get(player.getName());
                        if (!playerData3.arena.canUsefireWorks) {
                            player.sendMessage((String)this.plugin.customization.messages.get("fireworks_unavailable"));
                            return;
                        }
                        if (playerData3.hasCooldown(player, "firework", Config.getInstance().fireworksCooldown, true)) {
                            return;
                        }
                        final Firework firework = (Firework)player.getWorld().spawn(player.getLocation(), (Class)Firework.class);
                        final FireworkMeta fireworkMeta = firework.getFireworkMeta();
                        fireworkMeta.setPower(2);
                        fireworkMeta.addEffect(FireworkEffect.builder().flicker(true).withColor(Color.fromBGR(Utils.random.nextInt(256), Utils.random.nextInt(256), Utils.random.nextInt(256))).with(FireworkEffect.Type.BALL_LARGE).trail(true).build());
                        firework.setFireworkMeta(fireworkMeta);
                        final int j = playerData3.modifier * Config.getInstance().fireworksGivenCoins;
                        playerData3.addCoins(player, j);
                        final PlayerData playerData4 = playerData3;
                        playerData4.currentGameCoins += j;
                        final PlayerData playerData5 = playerData3;
                        ++playerData5.currentGameFireworks;
                        player.sendMessage(this.plugin.customization.messages.get("firework_use").replace("%earnedCoins%", String.valueOf(j)) + ((playerData3.modifier != 1) ? (ChatColor.YELLOW + " (x" + playerData3.modifier + ")") : ""));
                        if (player.getItemInHand().getAmount() > 1) {
                            player.getItemInHand().setAmount(player.getItemInHand().getAmount() - 1);
                        }
                        else {
                            player.setItemInHand(new ItemStack(Material.AIR));
                        }
                        return;
                    }
                    else {
                        if (((PlayerData)this.plugin.playerData.get(player.getName())).arena.seekers.contains(player.getName())) {
                            if (itemInHand.getType().equals((Object)Material.DIAMOND_AXE) || itemInHand.getType().equals((Object)Material.IRON_AXE)) {
                                playerInteractEvent.setCancelled(true);
                                if (((PlayerData)this.plugin.playerData.get(player.getName())).hasCooldown(player, "leap", Config.getInstance().LeapCooldown, true)) {
                                    return;
                                }
                                player.setVelocity(player.getEyeLocation().getDirection().multiply(Config.getInstance().leapMultiplier));
                                return;
                            }
                            else if (player.getItemInHand().getType().equals((Object)Perk.ThrowableTNT.purchased.getType())) {
                                playerInteractEvent.setCancelled(true);
                                if (((PlayerData)this.plugin.playerData.get(player.getName())).hasCooldown(player, "throwabletnt", Config.getInstance().ThrowabbleTNTCooldown, true)) {
                                    return;
                                }
                                final TNTPrimed tntPrimed = (TNTPrimed)player.getWorld().spawn(player.getLocation().add(0.0, 1.0, 0.0), (Class)TNTPrimed.class);
                                tntPrimed.setMetadata("damageHiders", (MetadataValue)new FixedMetadataValue((Plugin)this.plugin, (Object)true));
                                tntPrimed.setVelocity(player.getEyeLocation().getDirection().setY(0.3).multiply(1.5));
                                tntPrimed.setFuseTicks(30);
                                return;
                            }
                            else if (player.getItemInHand().getType().equals((Object)Perk.DisguisesDetector.purchased.getType())) {
                                playerInteractEvent.setCancelled(true);
                                if (((PlayerData)this.plugin.playerData.get(player.getName())).hasCooldown(player, "disguisedetector", Config.getInstance().DisguiseDetectorCooldown, true)) {
                                    return;
                                }
                                final Arena arena3 = this.plugin.playerData.get(player.getName()).arena;
                                final HashMap hashMap = new HashMap();
                                for (final Player player2 : arena3.getHiders()) {
                                    hashMap.put(player2.getName(), Math.ceil(player.getLocation().distance(player2.getLocation())));
                                }
                                player.sendMessage(ChatColor.DARK_AQUA + "      =================================== ");
                                player.sendMessage(" ");
                                int n3 = 0;
                                for (final String key : hashMap.keySet()) {
                                    if (n3 == 5) {
                                        break;
                                    }
                                    player.sendMessage("      " + ChatColor.YELLOW + key + ChatColor.AQUA + " - " + ChatColor.GREEN + hashMap.get(key) + " Blocks away" + ChatColor.AQUA + " - " + ChatColor.RED + ((ItemStack)arena3.playerDisguise.get(key)).getType().name());
                                    ++n3;
                                }
                                player.sendMessage(" ");
                                player.sendMessage(ChatColor.DARK_AQUA + "      =================================== ");
                                return;
                            }
                        }
                        if (itemInHand.getItemMeta().hasDisplayName() && itemInHand.getItemMeta().getDisplayName().contains(this.plugin.powerup_marker)) {
                            playerInteractEvent.setCancelled(true);
                            final Arena arena4 = this.plugin.playerData.get(player.getName()).arena;
                            if (arena4.hiders.contains(player.getName())) {
                                if (itemInHand.getType().equals((Object)Material.TNT)) {
                                    final TNTPrimed tntPrimed2 = (TNTPrimed)player.getWorld().spawn(player.getLocation().add(0.0, 1.0, 0.0), (Class)TNTPrimed.class);
                                    tntPrimed2.setMetadata("damageSeekers", (MetadataValue)new FixedMetadataValue((Plugin)this.plugin, (Object)true));
                                    tntPrimed2.setFuseTicks(40);
                                }
                                else if (itemInHand.getType().equals((Object)Material.EMERALD)) {
                                    final int k = Utils.random.nextInt(Config.getInstance().powerup_coins_max - Config.getInstance().powerup_coins_min) + Config.getInstance().powerup_coins_min;
                                    final PlayerData playerData6 = this.plugin.playerData.get(player.getName());
                                    playerData6.addCoins(player, k);
                                    final PlayerData playerData7 = playerData6;
                                    playerData7.currentGameCoins += k;
                                    player.sendMessage(this.plugin.customization.messages.get("coins_powerup").replace("%coins%", String.valueOf(k)));
                                }
                                else if (XMaterial.BREWING_STAND.isSimilar(itemInHand)) {
                                    player.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 300, 1));
                                    player.addPotionEffect(new PotionEffect(PotionEffectType.INCREASE_DAMAGE, 160, 0));
                                }
                                else if (XMaterial.CLOCK.isSimilar(itemInHand)) {
                                    final String string = this.plugin.customization.messages.get("powerup_effect_seekers").replace("%player%", player.getName()) + " (Blindness and slowness)";
                                    for (final Player player3 : arena4.getPlayers(true)) {
                                        player3.sendMessage(string);
                                        if (arena4.seekers.contains(player3.getName())) {
                                            player3.addPotionEffect(new PotionEffect(PotionEffectType.SLOW, 200, 1));
                                            player3.addPotionEffect(new PotionEffect(PotionEffectType.BLINDNESS, 200, 0));
                                        }
                                    }
                                }
                                else if (itemInHand.getType().equals((Object)Material.BRICK)) {
                                    final ArrayList room = Utils.getRoom(player.getLocation());
                                    boolean b = true;
                                    final Iterator iterator8 = room.iterator();
                                    while (iterator8.hasNext()) {
                                        if (((Location)iterator8.next()).getBlock().getType() != Material.AIR) {
                                            b = false;
                                            break;
                                        }
                                    }
                                    if (!b) {
                                        player.sendMessage((String)this.plugin.customization.messages.get("powerup_nospace"));
                                        return;
                                    }
                                    final ArrayList<BlockState> c2 = new ArrayList<BlockState>();
                                    for (final Location location : room) {
                                        c2.add(location.getBlock().getState());
                                        location.getBlock().setType(XMaterial.BRICKS.parseMaterial());
                                    }
                                    ((Location)room.get(0)).getBlock().setType(Material.GLOWSTONE);
                                    this.plugin.toRollback.addAll(c2);
                                    final ArrayList<Player> list2 = new ArrayList<Player>();
                                    for (final Entity entity : player.getNearbyEntities(10.0, 10.0, 10.0)) {
                                        if (entity.getType().equals((Object)EntityType.PLAYER)) {
                                            final Player e = (Player)entity;
                                            if (!arena4.seekers.contains(e.getName())) {
                                                continue;
                                            }
                                            list2.add(e);
                                            e.damage(2.0, (Entity)player);
                                        }
                                    }
                                    player.teleport(player.getLocation().add(0.0, 10.0, 0.0));
                                    final Iterator<Player> iterator11 = list2.iterator();
                                    while (iterator11.hasNext()) {
                                        iterator11.next().teleport((Entity)player);
                                    }
                                    for (int l = 0; l < 6; ++l) {
                                        final TNTPrimed tntPrimed3 = (TNTPrimed)player.getWorld().spawn(player.getLocation().add(0.0, 1.0, 0.0), (Class)TNTPrimed.class);
                                        tntPrimed3.setMetadata("damageSeekers", (MetadataValue)new FixedMetadataValue((Plugin)this.plugin, (Object)true));
                                        tntPrimed3.setFuseTicks(40 + l * 5);
                                    }
                                    if (!list2.isEmpty()) {
                                        final String string2 = this.plugin.customization.messages.get("powerup_effect_seekers").replace("%player%", player.getName()) + " (Death prison)";
                                        final Iterator iterator12 = arena4.getPlayers(true).iterator();
                                        while (iterator12.hasNext()) {
                                            ((Player)iterator12.next()).sendMessage(string2);
                                        }
                                    }
                                    Bukkit.getScheduler().scheduleSyncDelayedTask((Plugin)this.plugin, (Runnable)new Runnable() {
                                        @Override
                                        public void run() {
                                            final Iterator iterator = c2.iterator();
                                            while (iterator.hasNext()) {
                                                HASListener.this.plugin.Rollback((BlockState)iterator.next());
                                            }
                                            HASListener.this.plugin.toRollback.removeAll(c2);
                                        }
                                    }, 100L);
                                }
                                if (player.getItemInHand().getAmount() > 1) {
                                    player.getItemInHand().setAmount(player.getItemInHand().getAmount() - 1);
                                }
                                else {
                                    player.setItemInHand(new ItemStack(Material.AIR));
                                }
                            }
                            else {
                                player.setItemInHand((ItemStack)null);
                            }
                        }
                    }
                }
            }
            if (playerInteractEvent.getAction().equals((Object)Action.LEFT_CLICK_BLOCK)) {
                final Location location2 = playerInteractEvent.getClickedBlock().getLocation();
                if (this.plugin.disguisedBlocks.containsKey(location2)) {
                    final Player player4 = Bukkit.getPlayer((String)this.plugin.disguisedBlocks.get(location2));
                    if (!this.plugin.isOnSameTeam(player, player4)) {
                        final Arena arena5 = this.plugin.playerData.get(player4.getName()).arena;
                        this.plugin.disguisedBlocks.remove(location2);
                        arena5.hidden.remove(player4.getName());
                        arena5.nonhidden.add(player4.getName());
                        arena5.stillCounter.put(player4.getName(), arena5.hiders_become_solid_after);
                        player4.setLevel(arena5.hiders_become_solid_after);
                        for (final Player player5 : arena5.getPlayers(true)) {
                            player5.showPlayer(player4);
                            this.plugin.sendBlockChange(player5, location2, Material.AIR, 0);
                        }
                        player4.setVelocity(new Vector(0.0, 0.5, 0.0));
                        Utils.playSound(player, "Hider-Exposed");
                        Utils.playSound(player4, "Hider-Exposed");
                    }
                }
            }
        }
    }
    
    @EventHandler
    public void onEntityDamage(final EntityDamageEvent entityDamageEvent) {
        if (entityDamageEvent.isCancelled()) {
            return;
        }
        if (entityDamageEvent.getEntity().getType().equals((Object)EntityType.PLAYER)) {
            final Player player = (Player)entityDamageEvent.getEntity();
            if (this.plugin.game.contains(player.getName()) && (this.plugin.grace.contains(player.getName()) || (entityDamageEvent.getCause().equals((Object)EntityDamageEvent.DamageCause.FALL) && !Config.getInstance().FallDamageEnabled))) {
                entityDamageEvent.setCancelled(true);
            }
        }
    }
    
    @EventHandler
    public void onEntityDamageByEntity(final EntityDamageByEntityEvent entityDamageByEntityEvent) {
        if (entityDamageByEntityEvent.isCancelled()) {
            return;
        }
        if (entityDamageByEntityEvent.getEntity().getType().equals((Object)EntityType.PLAYER)) {
            final Player player = (Player)entityDamageByEntityEvent.getEntity();
            if (this.plugin.game.contains(player.getName())) {
                if (entityDamageByEntityEvent.getDamager().getType().equals((Object)EntityType.FIREWORK) && !Config.getInstance().FireworkDamageEnabled) {
                    entityDamageByEntityEvent.setCancelled(true);
                    return;
                }
                final boolean b = entityDamageByEntityEvent.getDamager() instanceof Projectile;
                Player player2 = null;
                if (b) {
                    final ProjectileSource shooter = ((Projectile)entityDamageByEntityEvent.getDamager()).getShooter();
                    if (shooter instanceof Player) {
                        player2 = (Player)shooter;
                    }
                }
                else if (entityDamageByEntityEvent.getDamager().getType().equals((Object)EntityType.PLAYER)) {
                    player2 = (Player)entityDamageByEntityEvent.getDamager();
                }
                else {
                    if (entityDamageByEntityEvent.getDamager().hasMetadata("damageSeekers")) {
                        if (((PlayerData)this.plugin.playerData.get(player.getName())).arena.hiders.contains(player.getName())) {
                            entityDamageByEntityEvent.setCancelled(true);
                        }
                        return;
                    }
                    if (entityDamageByEntityEvent.getDamager().hasMetadata("damageHiders")) {
                        if (((PlayerData)this.plugin.playerData.get(player.getName())).arena.seekers.contains(player.getName())) {
                            entityDamageByEntityEvent.setCancelled(true);
                        }
                        return;
                    }
                }
                if (player2 != null && this.plugin.game.contains(player2.getName())) {
                    if (this.plugin.isOnSameTeam(player, player2)) {
                        entityDamageByEntityEvent.setCancelled(true);
                    }
                    else {
                        Utils.playSound(player, "Player-Hit-Player");
                    }
                }
            }
        }
    }
    
    @EventHandler
    public void onEntityShootBowEvent(final ProjectileLaunchEvent projectileLaunchEvent) {
        final Projectile entity = projectileLaunchEvent.getEntity();
        if (entity.getShooter() != null && entity.getShooter() instanceof Player) {
            final Player player = (Player)entity.getShooter();
            if (this.plugin.game.contains(player.getName())) {
                final PlayerData playerData = this.plugin.playerData.get(player.getName());
                if (playerData.selectedTrail != null) {
                    new BukkitRunnable() {
                        final /* synthetic */ World val$w = player.getWorld();
                        final /* synthetic */ Effect val$effect = playerData.selectedTrail;
                        
                        public void run() {
                            this.val$w.playEffect(entity.getLocation(), this.val$effect, 1);
                            for (int i = 1; i < Config.getInstance().trailsSize; ++i) {
                                this.val$w.playEffect(entity.getLocation().add(Utils.random.nextDouble(), Utils.random.nextDouble(), Utils.random.nextDouble()), this.val$effect, 1);
                            }
                            if (!entity.isValid() || entity.isOnGround() || entity.getLocation().getY() < 0.0) {
                                this.cancel();
                            }
                        }
                    }.runTaskTimer((Plugin)this.plugin, 0L, (long)Config.getInstance().trailsInterval);
                }
            }
        }
    }
    
    @EventHandler
    public void PlayerCloseInventory(final InventoryCloseEvent inventoryCloseEvent) {
        this.plugin.shopping.remove(inventoryCloseEvent.getPlayer().getName());
    }
    
    @EventHandler
    public void onPlayerDeath(final PlayerDeathEvent playerDeathEvent) {
        final Player entity = playerDeathEvent.getEntity();
        if (this.plugin.game.contains(entity.getName())) {
            playerDeathEvent.setDeathMessage((String)null);
            playerDeathEvent.getDrops().clear();
            final Arena arena = this.plugin.playerData.get(entity.getName()).arena;
            entity.sendMessage((String)this.plugin.customization.messages.get("player_death"));
            final Player player = (entity.getKiller() != null && this.plugin.game.contains(entity.getKiller().getName())) ? entity.getKiller() : null;
            final ChatColor chatColor = (player != null) ? (arena.seekers.contains(player.getName()) ? ChatColor.RED : ChatColor.GREEN) : null;
            final String str = (chatColor != null) ? ((chatColor == ChatColor.RED) ? (ChatColor.RED + "Seeker") : (ChatColor.GREEN + "Hider")) : null;
            String s;
            if (player != null) {
                s = this.plugin.customization.messages.get("player_death_by_player_broadcast").replace("%team%", arena.seekers.contains(entity.getName()) ? (ChatColor.RED + "Seeker") : (ChatColor.GREEN + "Hider")).replace("%player%", entity.getName()).replace("%killer%", str + " " + player.getName());
            }
            else {
                s = this.plugin.customization.messages.get("player_death_broadcast").replace("%team%", arena.seekers.contains(entity.getName()) ? (ChatColor.RED + "Seeker") : (ChatColor.GREEN + "Hider")).replace("%player%", entity.getName());
            }
            final Iterator iterator = arena.getPlayers(true).iterator();
            while (iterator.hasNext()) {
                ((Player)iterator.next()).sendMessage(s);
            }
            if (XMaterial.supports(8)) {
                new BukkitRunnable() {
                    public void run() {
                        entity.spigot().respawn();
                    }
                }.runTaskLater((Plugin)HideAndSeek.getInstance(), 1L);
            }
            else {
                entity.setHealth(entity.getMaxHealth());
                entity.setFallDistance(0.0f);
                entity.setFireTicks(0);
                entity.getInventory().clear();
                final Iterator iterator2 = entity.getActivePotionEffects().iterator();
                while (iterator2.hasNext()) {
                    entity.removePotionEffect(((PotionEffect)iterator2.next()).getType());
                }
                if (((PlayerData)this.plugin.playerData.get(entity.getName())).hasPerk(Perk.SeekerSpeed)) {
                    entity.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 9999999, 0));
                }
                final Iterator iterator3 = arena.seekerEffects.iterator();
                while (iterator3.hasNext()) {
                    entity.addPotionEffect((PotionEffect)iterator3.next());
                }
            }
            if (arena.seekers.contains(entity.getName())) {
                if (player != null) {
                    final int modifier = this.plugin.playerData.get(player.getName()).modifier;
                    final int i = Config.getInstance().HiderKillSeekerEarnedCoins * modifier;
                    final int j = Utils.getRandomFromInterval(Config.getInstance().HiderKillSeekerMinEarnedExp, Config.getInstance().HiderKillSeekerMaxEarnedExp) * modifier;
                    this.playerKill(player, i, j, true);
                    player.sendMessage(this.plugin.customization.messages.get("player_kill").replace("%earnedCoins%", String.valueOf(i)).replace("%earnedExp%", String.valueOf(j)) + " " + ((modifier != 1) ? ("(x" + modifier + ")") : ""));
                }
                arena.respawnSeeker(entity, true);
            }
            else if (arena.hiders.contains(entity.getName())) {
                if (player != null) {
                    final int modifier2 = this.plugin.playerData.get(player.getName()).modifier;
                    final int k = Config.getInstance().SeekerKillHiderEarnedCoins * modifier2;
                    final int l = Utils.getRandomFromInterval(Config.getInstance().SeekerKillHiderMinEarnedExp, Config.getInstance().SeekerKillHiderMaxEarnedExp) * modifier2;
                    this.playerKill(player, k, l, false);
                    player.sendMessage(this.plugin.customization.messages.get("player_kill").replace("%earnedCoins%", String.valueOf(k)).replace("%earnedExp%", String.valueOf(l)) + " " + ((modifier2 != 1) ? ("(x" + modifier2 + ")") : ""));
                }
                arena.moveHiderToSeeker(entity);
                if (arena.hiders.isEmpty()) {
                    arena.finishGame(false);
                }
            }
        }
    }
    
    @EventHandler
    public void onPlayerRespawn(final PlayerRespawnEvent playerRespawnEvent) {
        final Player player = playerRespawnEvent.getPlayer();
        if (this.plugin.game.contains(player.getName())) {
            final Arena arena = this.plugin.playerData.get(player.getName()).arena;
            playerRespawnEvent.setRespawnLocation(arena.seekersWaitingSpawn);
            new BukkitRunnable() {
                public void run() {
                    if (arena.seekers.contains(player.getName())) {
                        if (HASListener.this.plugin.playerData.get(player.getName()).hasPerk(Perk.SeekerSpeed)) {
                            player.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 9999999, 0));
                        }
                        final Iterator iterator = arena.seekerEffects.iterator();
                        while (iterator.hasNext()) {
                            player.addPotionEffect((PotionEffect)iterator.next());
                        }
                    }
                }
            }.runTaskLater((Plugin)HideAndSeek.getInstance(), 1L);
        }
    }
    
    @EventHandler
    public void onPlayerChat(final PlayerChatEvent playerChatEvent) {
        final Player player = playerChatEvent.getPlayer();
        if (this.plugin.game.contains(player.getName())) {
            if (Config.getInstance().karmaEnabled) {
                final String stripColor = ChatColor.stripColor(playerChatEvent.getMessage().toLowerCase());
                if (stripColor.contains("gg") || stripColor.contains("good game") || stripColor.contains("goodgame")) {
                    final PlayerData playerData = this.plugin.playerData.get(player.getName());
                    if (playerData.arena != null && playerData.arena.state.equals((Object)Arena.ArenaState.ENDING)) {
                        if (playerData.hasCooldown(player, "gg", 20, false)) {
                            return;
                        }
                        final int i = Utils.random.nextInt(Config.getInstance().maxKarmaForSayingGG - Config.getInstance().minKarmaForSayingGG) + Config.getInstance().minKarmaForSayingGG;
                        final PlayerData playerData2 = this.plugin.playerData.get(player.getName());
                        playerData2.karma += i;
                        player.sendMessage(this.plugin.customization.messages.get("player_earn_karma").replace("%earnedKarma%", String.valueOf(i)));
                    }
                }
            }
            if (Config.getInstance().modifychat) {
                final PlayerData playerData3 = this.plugin.playerData.get(player.getName());
                playerChatEvent.setFormat(Config.getInstance().chatModification.replace("%rank%", playerData3.rank.name).replace("%coins%", String.valueOf(playerData3.getCoins(player))).replace("%exp%", String.valueOf(playerData3.playerExp)) + " " + playerChatEvent.getFormat());
            }
        }
    }
    
    @EventHandler
    public void onPlayerCreateSign(final SignChangeEvent signChangeEvent) {
        final Player player = signChangeEvent.getPlayer();
        if (signChangeEvent.getLine(0).equalsIgnoreCase("[Has]")) {
            if (player.hasPermission("hideandseek.createsigns")) {
                signChangeEvent.setLine(0, this.plugin.customization.sign_prefix);
                final String lowerCase = signChangeEvent.getLine(1).toLowerCase();
                if (lowerCase.equals("stats") || lowerCase.equals("leave") || lowerCase.equals("join") || lowerCase.equals("autojoin") || lowerCase.equals("shop") || lowerCase.equals("top")) {
                    if (lowerCase.equals("stats")) {
                        signChangeEvent.setLine(1, this.plugin.customization.sign_stats);
                        player.sendMessage(this.plugin.customization.prefix + "You have created a " + ChatColor.YELLOW + lowerCase + ChatColor.GOLD + " sign!");
                    }
                    else if (lowerCase.equals("leave")) {
                        signChangeEvent.setLine(1, this.plugin.customization.sign_leave);
                        player.sendMessage(this.plugin.customization.prefix + "You have created a " + ChatColor.YELLOW + lowerCase + ChatColor.GOLD + " sign!");
                    }
                    else if (lowerCase.equals("join")) {
                        final Arena value = Arena.valueOf(signChangeEvent.getLine(2));
                        if (value == null) {
                            if (this.plugin.joinGui != null) {
                                signChangeEvent.setLine(1, this.plugin.customization.sign_join_default);
                                signChangeEvent.setLine(2, "");
                                signChangeEvent.setLine(3, "");
                                player.sendMessage(this.plugin.customization.prefix + "Couldn't find an arean with a name mentioned in the second line, due to that, no arena was specified!");
                            }
                            else {
                                player.sendMessage((String)this.plugin.customization.messages.get("unknown_arena"));
                            }
                            return;
                        }
                        if (FilesManager.getInstance().getConfig("signs.yml").contains("Signs.Join." + value.name)) {
                            player.sendMessage(this.plugin.customization.prefix + "You may not have more than 1 join sign per arena!");
                            return;
                        }
                        final Location location = signChangeEvent.getBlock().getLocation();
                        FilesManager.getInstance().getConfig("signs.yml").set("Signs.Join." + value.name, (Object)(location.getWorld().getName() + ", " + location.getBlockX() + ", " + location.getBlockY() + ", " + location.getBlockZ()));
                        FilesManager.getInstance().saveConfig("signs.yml");
                        value.sign = location;
                        signChangeEvent.setLine(1, this.plugin.customization.sign_join_line2_color + value.name);
                        signChangeEvent.setLine(2, value.state.text);
                        signChangeEvent.setLine(3, this.plugin.customization.sign_join_line4_format.replace("%players%", String.valueOf(value.players.size())).replace("%maxplayers%", String.valueOf(value.maxPlayers)));
                        value.updateBehindSign();
                        value.updateStateBlock();
                        player.sendMessage(this.plugin.customization.prefix + "You have created a " + ChatColor.YELLOW + lowerCase + ChatColor.GOLD + " sign!");
                    }
                    else if (lowerCase.equals("autojoin")) {
                        signChangeEvent.setLine(1, this.plugin.customization.sign_autojoin);
                        player.sendMessage(this.plugin.customization.prefix + "You have created a " + ChatColor.YELLOW + lowerCase + ChatColor.GOLD + " sign!");
                    }
                    else if (lowerCase.equals("shop")) {
                        signChangeEvent.setLine(1, this.plugin.customization.sign_shop);
                        player.sendMessage(this.plugin.customization.prefix + "You have created a " + ChatColor.YELLOW + lowerCase + ChatColor.GOLD + " sign!");
                    }
                    else if (lowerCase.equals("top")) {
                        if (Utils.isNumber(signChangeEvent.getLine(2))) {
                            final int int1 = Integer.parseInt(signChangeEvent.getLine(2));
                            if (int1 > 0) {
                                final FileConfiguration config = FilesManager.getInstance().getConfig("signs.yml");
                                final String string = "Signs.Top." + int1;
                                if (config.contains(string)) {
                                    player.sendMessage(this.plugin.customization.prefix + "You have already made a top sign that looks for the rank " + ChatColor.AQUA + int1);
                                    return;
                                }
                                final Location location2 = signChangeEvent.getBlock().getLocation();
                                config.set(string + ".world", (Object)location2.getWorld().getName());
                                config.set(string + ".x", (Object)location2.getX());
                                config.set(string + ".y", (Object)location2.getY());
                                config.set(string + ".z", (Object)location2.getZ());
                                FilesManager.getInstance().saveConfig("signs.yml");
                                signChangeEvent.setLine(1, "Top #" + int1);
                                signChangeEvent.setLine(2, "WAITING");
                                signChangeEvent.setLine(3, "(0)");
                                player.sendMessage(this.plugin.customization.prefix + "You have created a " + ChatColor.YELLOW + lowerCase + ChatColor.GOLD + " sign!");
                                if (this.plugin.fixUpdater()) {
                                    player.sendMessage(this.plugin.customization.prefix + "Sign updater has been enabled");
                                }
                                else {
                                    player.sendMessage(this.plugin.customization.prefix + "Sign updater is already enabled, so you must wait till next update to see results");
                                }
                            }
                            else {
                                player.sendMessage(this.plugin.customization.prefix + "Third line must be a number above 0");
                            }
                        }
                        else {
                            player.sendMessage(this.plugin.customization.prefix + "Third line must be a number (Its the rank you want to display)");
                        }
                    }
                }
                else {
                    player.sendMessage(this.plugin.customization.prefix + "Second line must be one of these options, join/leave/stats/autojoin/top");
                    signChangeEvent.setLine(1, ChatColor.DARK_RED + "Wrong");
                }
            }
            else {
                player.sendMessage((String)this.plugin.customization.messages.get("no_permission"));
                signChangeEvent.setCancelled(true);
            }
        }
    }
    
    @EventHandler
    public void onPlayerMove(final PlayerMoveEvent playerMoveEvent) {
        final Player player = playerMoveEvent.getPlayer();
        if (this.plugin.disguisedBlocks.containsValue(player.getName())) {
            final Location from = playerMoveEvent.getFrom();
            final Location to = playerMoveEvent.getTo();
            if (from.getBlockX() != to.getBlockX() || from.getY() != to.getY() || from.getBlockZ() != to.getBlockZ()) {
                player.sendMessage((String)this.plugin.customization.messages.get("player_move"));
                this.plugin.disguisedBlocks.remove(from.getBlock().getLocation());
                final Arena arena = this.plugin.playerData.get(player.getName()).arena;
                arena.hidden.remove(player.getName());
                arena.nonhidden.add(player.getName());
                final int n = this.plugin.playerData.get(player.getName()).hasPerk(Perk.InstaSolid) ? 1 : arena.hiders_become_solid_after;
                arena.stillCounter.put(player.getName(), n);
                player.setLevel(n);
                for (final Player player2 : arena.getPlayers(true)) {
                    player2.showPlayer(player);
                    this.plugin.sendBlockChange(player2, from, Material.AIR, 0);
                }
            }
        }
    }
    
    @EventHandler
    public void blockCommand(final PlayerCommandPreprocessEvent playerCommandPreprocessEvent) {
        final Player player = playerCommandPreprocessEvent.getPlayer();
        if (!player.hasPermission("hideandseek.unblockcommands")) {
            final String lowerCase = playerCommandPreprocessEvent.getMessage().split(" ")[0].replace("/", "").toLowerCase();
            if (this.plugin.game.contains(player.getName()) && !Config.getInstance().allowedCommands.contains(lowerCase)) {
                playerCommandPreprocessEvent.setCancelled(true);
                player.sendMessage((String)this.plugin.customization.messages.get("blocked_cmd"));
            }
        }
    }
    
    @EventHandler
    public void onTeleport(final PlayerTeleportEvent playerTeleportEvent) {
        final Player player = playerTeleportEvent.getPlayer();
        if (this.plugin.game.contains(player.getName())) {
            final Arena arena = this.plugin.playerData.get(player.getName()).arena;
            if (arena.hidden.contains(player.getName())) {
                arena.hidden.remove(player.getName());
                arena.nonhidden.add(player.getName());
                arena.removeHidden(player);
            }
        }
    }
    
    @EventHandler
    public void onPing(final ServerListPingEvent serverListPingEvent) {
        if (Config.getInstance().bungeeEnabled) {
            if (this.plugin.bungeeMode.selectedArena != null) {
                if (this.plugin.bungeeMode.selectedArena.state.equals((Object)Arena.ArenaState.WAITING)) {
                    serverListPingEvent.setMotd(Arena.ArenaState.INGAME.text);
                }
                else {
                    serverListPingEvent.setMotd(this.plugin.bungeeMode.selectedArena.state.text);
                }
            }
            else {
                serverListPingEvent.setMotd(Arena.ArenaState.WAITING.text);
            }
        }
    }
    
    public void playerKill(final Player player, final int n, final int n2, final boolean b) {
        final PlayerData playerData = this.plugin.playerData.get(player.getName());
        if (b) {
            final PlayerData playerData2 = playerData;
            ++playerData2.seekersKilled;
            AchievementsManager.getInstance().checkPlayer(player, AchievementsManager.AchievementType.SEEKERS_KILLED, playerData.seekersKilled);
        }
        else {
            final PlayerData playerData3 = playerData;
            ++playerData3.hidersKilled;
            AchievementsManager.getInstance().checkPlayer(player, AchievementsManager.AchievementType.HIDERS_KILLED, playerData.hidersKilled);
        }
        playerData.addCoins(player, n);
        final PlayerData playerData4 = playerData;
        playerData4.playerExp += n2;
        final PlayerData playerData5 = playerData;
        playerData5.currentGameCoins += n;
        final PlayerData playerData6 = playerData;
        playerData6.currentGameExp += n2;
        if (playerData.rank.nextRank != null && playerData.rank.nextRank.requiredExp <= playerData.playerExp) {
            playerData.rank = playerData.rank.nextRank;
            final Iterator iterator = playerData.rank.commandsExecuted.iterator();
            while (iterator.hasNext()) {
                Bukkit.dispatchCommand((CommandSender)this.plugin.console, ((String)iterator.next()).replace("%player%", player.getName()).replace("%newrank%", playerData.rank.name));
            }
            final Arena arena = this.plugin.playerData.get(player.getName()).arena;
            final String replace = this.plugin.customization.messages.get("rankup_broadcast").replace("%player%", player.getName()).replace("%rank%", playerData.rank.name);
            final Iterator iterator2 = arena.getPlayers(true).iterator();
            while (iterator2.hasNext()) {
                ((Player)iterator2.next()).sendMessage(replace);
            }
        }
    }
}
